from setuptools import setup

setup(
	name = 'helium',
	version = '1.6.6',
	author = 'BugFree Software',
	author_email = 'contact@heliumhq.com',
	description = 'Simple web automation based on Selenium.',
	keywords = 'selenium web automation',
	url = 'http://heliumhq.com',
	classifiers = [
		'Development Status :: 5 - Production/Stable',
		'Intended Audience :: Developers',
		'License :: Other/Proprietary License',
		'Topic :: Software Development :: Testing',
		'Topic :: Software Development :: Libraries',
		'Programming Language :: Python',
		'Programming Language :: Python :: 2.6',
		'Programming Language :: Python :: 2.7',
		'Programming Language :: Python :: 3.2',
		'Programming Language :: Python :: 3.3',
		'Operating System :: POSIX :: Linux',
		'Operating System :: MacOS :: MacOS X',
		'Operating System :: Microsoft :: Windows'
	],
	packages = [
		'bfs',
		'helium',
		'bfs.bfs10077',
		'bfs.bfs10135',
		'helium.bfs10077',
		'helium.bfs10135',
		'helium.bfs10146'
	],
	package_dir = {'helium': 'heliumlib/helium', 'bfs': 'heliumlib/bfs'},
	install_requires = [
		'selenium==2.41.0', 'springpython>=1.2.1',
		'pkcs1>=0.9.5', 'decorator>=3.4.0'
	],
	package_data = {
		'helium.bfs10135': ['*.py3'],
		'bfs': ['*.py3'],
		'helium.bfs10146': ['*.py3'],
		'helium.bfs10077': ['*.py3'],
		'bfs.bfs10135': ['*.py3'],
		'helium': ['*.py3', 'data/*.*', 'data/linux/webdrivers/*', 'data/macosx/webdrivers/*', 'data/win/webdrivers/*'],
		'bfs.bfs10077': ['*.py3']
	},
	zip_safe = False
)